# until defined for all current releases
%{!?_pkgdocdir: %global _pkgdocdir %{_docdir}/%{name}-%{version}}

%global checkout 20130515svn

Name:           cbmc
Version:        4.3
Release:        7.%{checkout}%{?dist}
Summary:        Bounded Model Checker for ANSI-C and C++ programs

License:        BSD with advertising
URL:            http://www.cprover.org/cbmc/

# The source for this package was pulled from upstream's vcs.  Use the
# following commands to generate the tarball:
#  svn export -r 2441 http://www.cprover.org/svn/cbmc/releases/cbmc-4.3 cbmc-4.3-20130515svn
# tar czvf cbmc-4.3-20130515svn.tar.gz cbmc-4.3-20130515svn
Source0:        cbmc-%{version}-%{checkout}.tar.gz
Source1:        cbmc-20130515-regression.Makefile
Patch0:         cbmc-%{checkout}-fix-build.patch
Patch1:         cbmc-%{checkout}-regression-test.patch
Patch2:         cbmc-%{checkout}-no-long_width.patch

BuildRequires:  flex
BuildRequires:  bison
BuildRequires:  zlib-devel
BuildRequires:  minisat2-devel

%description
CBMC generates traces that demonstrate how an assertion can be violated, or
proves that the assertion cannot be violated within a given number of loop
iterations.

%prep
%setup -q -n %{name}-%{version}-%{checkout}
cp %{SOURCE1} regression/Makefile
%patch0 -p1
%patch1 -p1
%patch2 -p1

%build
make %{?_smp_mflags} -C src

%install
mkdir -p %{buildroot}%{_bindir} %{buildroot}%{_pkgdocdir}/%{name}-%{version} %{buildroot}%{_mandir}/man1
install -p src/cbmc/cbmc %{buildroot}%{_bindir}
install -p src/goto-cc/goto-cc %{buildroot}%{_bindir}
install -p src/goto-instrument/goto-instrument %{buildroot}%{_bindir}
cp -pr doc/html-manual %{buildroot}%{_pkgdocdir}/%{name}-%{version}
install -p doc/man/cbmc.1 %{buildroot}%{_mandir}/man1

%check
cd regression
make

%files
%doc CHANGELOG CODING_STANDARD LICENSE
%{_bindir}/cbmc
%{_bindir}/goto-cc
%{_bindir}/goto-instrument
%{_mandir}/man1/cbmc.*

%changelog
* Tue Sep 10 2013 Shakthi Kannan <shakthimaan [AT] fedoraproject.org> - 4.3-7.20130515svn
- Fix build with unversioned docdir using _pkgdocdir (#992043)

* Sat Aug 03 2013 Fedora Release Engineering <rel-eng@lists.fedoraproject.org> - 4.3-6.20130515svn
- Rebuilt for https://fedoraproject.org/wiki/Fedora_20_Mass_Rebuild

* Wed Jul 10 2013 Dan Horák <dan[at]danny.cz> - 4.3-5.20130515svn
- fix build on s390x

* Mon Jul  8 2013 Shakthi Kannan <shakthimaan [AT] fedoraproject.org> - 4.3-4.20130515svn
- Fixed changelog date

* Sun Jun 30 2013 Shakthi Kannan <shakthimaan [AT] fedoraproject.org> - 4.3-3.20130515svn
- Updated license
- Fixed doc and manual page directories

* Tue Jun 25 2013 Shakthi Kannan <shakthimaan [AT] fedoraproject.org> - 4.3-2.20130515svn
- Updated release

* Wed May 15 2013 Shakthi Kannan <shakthimaan [AT] fedoraproject.org> - 4.3-1.20130515svn
- First release
